function [Ome, de] = fMatPen(x,K)
% Przyklad 20.7
% x - analizowany sygnal - suma tlumionych sinusoid rzeczywistych
% K - zalozona liczba skladowych
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

M = 2*K;                        % liczba skladowych zespolonych
N = length(x);                  % liczba probek sygnalu
L = floor(N/3);                 % przyjety rzad liniowej predykcji L = N/3
X = hankel(x(1:N-L),x(N-L:N));  % X0=X(:,1:L), X1=X(:,2:L+1)
[U,S,V] = svd(X(:,2:L+1), 0); S = diag(S);                            % SVD( X1 )
p = log( eig( diag(1./S(1:M)) * ((U(:,1:M)'*X(:,1:L))*V(:,1:M)) ) );  % ln(EVD( Z ))
Om = imag(p); [Om indx] = sort( Om, 'descend' ); Ome = Om(1:K);       % pulsacja
de = real(p(indx(1:K)));        % tlumienie